---
title: How to create an interactive learning exercise
slug: MDN/Contribute/Howto/Create_an_interactive_exercise_to_help_learning_the_web
tags:
  - Guide
  - Howto
  - Intermediate
  - Learning
  - MDN Meta
  - Tutorial
---
<div>{{MDNSidebar}}</div>

<p>When learning the web, it's important to rely on active learning content. Such content is made to help with learning something pro-actively. It can be exercises, live hackable examples, tasks to perform, assessments, etc. In short, anything that can help someone to actively understand something.</p>

<p>There is no straightforward way to create such content. For example many third party tools exist that can help you create live hackable examples (see: <a href="https://jsfiddle.net/" rel="external">JSFiddle</a>, <a href="https://codepen.io/">CodePen</a>, <a href="http://dabblet.com/">Dabblet</a>, etc.) that you can link from MDN articles. If you want to create more advanced comprehensible exercises, you can easily use <a href="https://thimble.mozilla.org" rel="external">Thimble</a> from the WebMaker project.</p>

<p>Currently, MDN does not have an easy tool to author such active content. However, if you are a coder you can use the current MDN features to create custom active learning content.</p>

<h2 id="MDN_live_samples">MDN live samples</h2>

<p>MDN has a very cool feature called <strong>live samples</strong>. It's a mechanism that turns any HTML, CSS, and JavaScript code inside an MDN page into its executed equivalent. Before using it, you should read over <a href="/en-US/docs/MDN/Structures/Live_samples">Using the live sample system</a>, which is our complete documentation for building them. While they're easy to create, there are quirks and tricks you'll learn along the way.</p>

<p>What is interesting is that it's really easy to tweak that feature to use it in order to embed any kind of tool or utility you want into an MDN page.</p>

<h3 id="Hidden_code">Hidden code</h3>

<p>The first way to use a code sample to create active learning content is to edit the page where you want to add your content. Use the Live Sample feature to create your content as you wish. Don't bother with the code complexity you could write; just create what you need. Once your content is ready, just switch to the editor code view and surround your code with a simple {{HTMLElement('div')}} element with the class <code>hidden</code>. By doing so, your code won't be displayed but your live sample remains accessible and displayable.</p>

<p>Let's see a simple example:</p>

<div class="moreinfo">
<p>Click on the following square to randomly change its color:</p>

<div class="hidden">
<h4 id="hidden_code_example">hidden code example</h4>

<h5 id="HTML">HTML</h5>

<pre class="brush: html">&lt;div class="square"&gt;
  &lt;p class="color"&gt;#000000&lt;/p&gt;
&lt;/div&gt;</pre>

<h5 id="CSS">CSS</h5>

<pre class="brush: css">body {
  padding: 10px;
  margin : 0;
}

.square {
  width  : 80px;
  height : 80px;
  padding: 10px;
  background-color: black;
  color: white;
  text-align: center;
}

.color {
  width: 60px;
  text-shadow: 1px 1px 1px black;
}
</pre>

<h5 id="JS">JS</h5>

<pre class="brush: js">function setColor(color) {
  document.querySelector('.square').style.backgroundColor = '#' + color;
  document.querySelector('.color').textContent = '#' + color;
}

function getRandomColor() {
  var color = Math.floor(Math.random() * 16777215);
  return color.toString(16);
}

document.addEventListener('click', function (e) {
  setColor(getRandomColor());
});
</pre>
</div>
{{EmbedLiveSample('hidden_code_example', 120, 125)}}</div>

<p>If you take a look at the source code of this page, you'll see the following HTML code:</p>

<pre class="brush: html">&lt;div class="moreinfo"&gt;
&lt;p&gt;Click on the following square to randomly change its color or just type an hexadecimal code color&lt;/p&gt;

&lt;div class="hidden"&gt;
&lt;h4 id="hidden_code_example"&gt;hidden code example&lt;/h4&gt;

&lt;h5 id="HTML"&gt;HTML&lt;/h5&gt;

&lt;pre class="brush: html"&gt;
&amp;lt;div class="square"&amp;gt;
  &amplt;p class="color"&amp;gt;#000000&amp;lt;/p&amp;gt;
&amp;lt;/div&amp;gt;&lt;/pre&gt;

&lt;h5 id="CSS"&gt;CSS&lt;/h5&gt;

&lt;pre class="brush: css"&gt;
body {
  padding: 10px;
  margin : 0;
}

.square {
  width  : 80px;
  height : 80px;
  padding: 10px;
  background-color: black;
  color: white;
  text-align: center;
}

.color {
  width: 60px;
  text-transform: uppercase;
}
&lt;/pre&gt;

&lt;h5 id="JS"&gt;JS&lt;/h5&gt;

&lt;pre class="brush: js"&gt;
function setColor(color) {
  document.querySelector('.square').style.backgroundColor = '#' + color;
  document.querySelector('.color').textContent = '#' + color;
}

function getRandomColor() {
  var color = Math.floor(Math.random() * 16777215);
  return color.toString(16);
}

document.addEventListener('click', function (e) {
  setColor(getRandomColor());
});
&lt;/pre&gt;
&lt;/div&gt;

\{{EmbedLiveSample('hidden_code_example', 120, 125)}}
&lt;/div&gt;</pre>

<p>You can see a more advanced example of such a tweak on <a href="/en-US/docs/Web/API/Canvas_API#JavaScript">the Canvas API page</a>.</p>

<h3 id="Code_from_outside_the_page">Code from outside the page</h3>

<p>The previous example is okay if you want to embed basic active learning content. However, if you want to deal with complex code, it can become a bit awkward to deal with that <code>hidden</code> class wrapper.</p>

<p>So another option is to write the code of your learning content on an MDN page and then embed it into another page. To do this we can use the {{TemplateLink("EmbedDistLiveSample")}} macro instead of the {{TemplateLink("EmbedLiveSample")}} macro.</p>

<p>Let's how that sample looks when configured as if it were being embedded from a remote origin:</p>

<div class="moreinfo">
<p>Click on the following square to randomly change its color or just type a hexadecimal code color</p>
{{EmbedLiveSample('The_example', 120, 125, '', 'MDN/Contribute/Howto/Create_an_interactive_exercise_to_help_learning_the_web/distant_example')}}</div>

<p>This time, if you take a look at that page's source, you'll see no hidden code. If you want to see the code, just go to <a href="/en-US/docs/MDN/Contribute/Howto/Create_an_interactive_exercise_to_help_learning_the_web/distant_example">the page that hosts it</a>.</p>
